

!******************************************************************************
!******************************************************************************
!******************************************************************************

module basics

contains

!*************************** reading of answers *******************************

logical function affirm(str)

  implicit none
!variables
  character(len=*), intent(in):: str
  character(len=1) taste 
  integer j

!initializing
  j=len(str)

!question and answer
  write(*, '(A)',advance="no") str(1:j)
  read(*, '(A1)') taste
  
  if (taste=='y'.or.taste=='Y') then
     affirm=.true.
  else
     affirm=.false.
  end if

end function affirm


!******************************** open files **********************************

subroutine fileopen(channel, fstr1, fstr)

  implicit none

!variables
  integer, intent(in)::channel
  character(len=*), intent(in)::fstr1
  character(len=*), intent(inout):: fstr
  character(len=18) fstr2
  logical tab
  integer error, j

!initializing
  error=1

!reading name and open file
  do while (error/=0)
     print*, 'Ausgabefile:'
     read(*,*) fstr2
     fstr=fstr1//fstr2

     open(channel, file=fstr, iostat=error, access='sequential', status='new')

     if (error/=0) then
        print *, 'File already existent!:'
        close(channel, status='delete')
        tab=affirm('Overwrite?')
        if (tab) then
           open(channel, file=fstr, status='old')
           close(channel, status='delete')
           open(channel, file=fstr, iostat=error,&
                & access='sequential', status='new')
           error=0
        end if
     end if
  end do

end subroutine fileopen

!*************************** reading of variables *****************************

integer function iinp(str)

  implicit none
  character(len=*), intent(in)::str

  write(*, '(A)',advance="no") str
  read(*,*) iinp

end function iinp

!***********************************
double precision function rinp(str)

  implicit none
  character(len=*), intent(in)::str

  write(*, '(A)',advance="no") str
  read(*,*) rinp

end function

!*************************************
character function strinp(str)

  implicit none
  character(len=*), intent(in)::str

  write(*, '(A)',advance="no") str
  read(*, fmt='(A)') strinp

end function

end module
