/* PROGRAMM	BESTIMMT DIE LOESUNG DER STATIONAEREN SCHROEDINGERGLEICHUNG	*/
/* AN EINER	STELLE > GRENZE. ES	WIRD DER WERT DER LOGARITHMISCHEN ABLEI-*/
/* TUNG	f(x)/x UND DIE STELLE, AN DER SIE GEBILDET WIRD	ZURCKGEGEBEN	*/

#ifndef	__NUMEROW
#define	__NUMEROW

/* #define __TEST_NUMEROW */	          /* Beim Ausfuehren nur dieser	*/
/* #define E_I_STREUUNG */ 	   /* Funktion Kommentare entfernen	*/

#include "quer.h"

TYP	schroeder(TYP (*pot)(TYP x,TYP kappa),TYP a,TYP	x,TYP kappa,int	l)
{
TYP	zwi;
zwi=((l*(l+1))/(x*x))+pot(x,kappa)-(a*a);
return zwi;
}

struct NUMEROW numerow(TYP a,int l,TYP kappa,int grenze)
{
struct NUMEROW erg;
TYP	zwi1,zwi2,zwi3;
TYP	ableit;
TYP	h=step;
TYP	x=step;
TYP	y1,y2,y3;
TYP	wf;

if	 (l==0)	y1=-(h*h)/12.;
if	 (l==1)	y1=-(h*h)/18.;
else y1=0;
zwi1=(1/(2.*l+3))*((4./(2.*l+2.))+2.*kappa-(a*a));
zwi2=-(kappa*kappa)-(zwi1+(2.*kappa-(a*a))/(l+1));
zwi3=1-2.*h/(2.*(l+1))+(h*h)*zwi1/2.+((h*h*h)/(6*(l+2)))*zwi2;
wf=pow(h,(l+1))*zwi3/(2.*l+1.);
if (wf<1.0e-250) wf=1.0e-252;
y2=wf*(1.-((h*h)/12.)*schroeder(pot,a,step,kappa,l));
y3=1.0;
do
{
 if( fabs(y3)>1.0e+50)
   {  y1=y1*1.0e-25;
      y2=y2*1.0e-25;
      y3=y3*1.0e-25; }
 if( fabs(y3)<1.0e-50)
   {  y1=y1*1.0e+25;
      y2=y2*1.0e+25;
      y3=y3*1.0e+25; }

 wf=y2/(1.-((h*h)/12.)*schroeder(pot,a,x,kappa,l));
 y3=2.*y2-y1+(h*h)*schroeder(pot,a,x,kappa,l)*wf;
 if ( fabs(x-grenze)<step/2.)
   {	zwi1=y1/(1.-(h*h)*schroeder(pot,a,x-step,kappa,l));
	zwi2=y2/(1.-(h*h)*schroeder(pot,a,x,kappa,l));
	zwi3=y3/(1.-(h*h)*schroeder(pot,a,x+step,kappa,l));
	if (fabs(zwi2)<1.e-280)	grenze++;
   };
 y1=y2;
 y2=y3;
 x+=step;
}
while ((x-(grenze+1))<step/2.);
ableit=(((zwi3-zwi2)/step)+((zwi2-zwi1)/step))/2.0;
erg.logabl=ableit/zwi2-(1./grenze);
erg.grenze=grenze;
return erg;
}

#ifdef __TEST_NUMEROW

int	main (void)
{
TYP	a=10.0;
int	l=1;
TYP	kappa=1.0;
TYP schritt[20];
int	i,grenze;
struct NUMEROW erg;

printf("\n\n		 BITTE WARTEN	!!\n\n");

step=0.001;
Z=1.0;
setzen();

schritt[1]=0.02;
schritt[2]=0.01;
schritt[3]=0.005;
schritt[4]=0.0025;
schritt[5]=0.002;
schritt[6]=0.001;
schritt[7]=0.0005;
schritt[8]=0.00025;
schritt[9]=0.0002;
schritt[10]=0.0001;
schritt[11]=0.00005;
schritt[12]=0.000025;
schritt[13]=0.00002;
schritt[14]=0.00001;

grenze=30;
step=0.01;
for(i=1;i<15;i++)
  { step=schritt[i];
    erg=numerow(a,l,kappa,grenze);
    printf("step=%le erg=%le bei x= %d\n",step,erg.logabl,erg.grenze); }
printf("\n\n");
printf("	               FERTIG : BITTE ENTER DRUECKEN !!");
getchar();
getchar();
return 0;
}

#endif
#endif
