/* PROGRAMM	BERECHNET DIE STREUPHASEN DES DREHIMPULSES l FUER DAS DEBEYPOTENTIAL */

#ifndef	__PHASE
#define	__PHASE

/* #define __TEST_PHASE */		/* Beim Ausfuehren nur dieser */
/* #define E_I_STREUUNG	*/	   /* Funktion Kommentare entfernen	*/
 

#include "quer.h"
#include "grenze.c"
#include "bessel.c"
#include "numerow.c"

TYP	phasen (TYP a, int l, TYP kappa)
{
struct ZYLFUNKT	 beserg;
struct NUMEROW	numerg;
TYP		 zwo,zwu;
TYP		 phase_l;
int		 grenze;

grenze=cutoff(pot,a,kappa,POTTEIL);
numerg=numerow(a,l,kappa,grenze);
beserg=bessel(a*numerg.grenze,l);
zwo=(a*beserg.besabl)-(numerg.logabl*beserg.bessel);
zwu=(a*beserg.neuabl)-(numerg.logabl*beserg.neuman);
phase_l=atan2(zwo,zwu);
if (phase_l > (MM_PI/2.0))	phase_l-=MM_PI;	
if (phase_l < -(MM_PI/2.0))	phase_l+=MM_PI;
return phase_l;
}

#ifdef __TEST_PHASE

int	main(void)
{
FILE *out;
TYP	ergeb;
int	grenze;
int	maxi=GRENZMAX;
TYP	a=0.01;
int	l=1;
TYP	kappa=1.0;
int	i;
TYP	schritt[20];

step=0.001;
Z=1.0;

out=fopen("phase.dat","w");
printf("\n\n");
grenze=cutoff(pot,a,kappa,POTTEIL);
if(grenze==-1)
  {
   printf("				 Die eingegebenen Daten");
   printf("	( ENERGIE und KAPPA	) wuerden\n\n");
   printf("			  eine zu weite	Integration	verlangen");
   printf("	( >	%d Bohrradien )",maxi);
   printf("\n\n\n\n\n\n");
   printf("				Berechnung der Streuphase");
   printf("	mit	einem anderen Verfahren\n\n");
   printf("		  oder maximale	Integrationsgrenze in der");
   printf("	Datei '	QUER.H ' aendern !");
   getchar();
   getchar();
   return 0;
  }

printf(" BITTE WARTEN !!\n\n");

for(i=0;i<80;i++)
 { l=i;
   ergeb=phasen(a,l,kappa);
   printf("%d %le\n",l,ergeb);
   fprintf(out,"%d %le\n",l,ergeb);	  
 }

/*ergeb=phasen(a,l,kappa);
printf(" Streuphase	: %+.4le\n\n",ergeb);*/

fclose(out);
printf(" FERTIG	!!\n\n");
getchar();
getchar();
return 0;
}

#endif
#endif
