/* Dieses Programm berechnet Streuphasen fuer verschiedene Streuungen (z.B. 
   e-i-Streuung) mittels Numerov-Verfahren. Die Schroedingergleichung ist dazu 
   mit einer Laenge a_0=/hbar^2/e^2/m_red dimensionslos gemacht, 
   wobei m_red die reduzierte Masse der Streuer ist. Das heisst, dass alle 
   Laengen in Einheiten von a_0 benutzt werden!

   Ref: Programm von Dirk Gericke, Uni HGW

   Sandra Kuhlbrodt, 04.08.2000 
*/

#include "quer.h"
#include "phase.c"
#include "k-ende.c"

TYP	phas(TYP a,int l,TYP kappa,int was)
{
TYP	erg;

if(	was<0.0	) return 0.0;
else erg=phasen(a,l,kappa);
return erg;
}

int	mainei_(void)
{
FILE    *dat;
FILE    *datl1;
TYP     ergebnis;
int     grenze;
TYP     a,zwi;
int     l,next;

int	drehimpend,l_max,max_l;
TYP	kappa,ladung,dipol,r0pol,schritt;
TYP	rela_born1,rela_born2;
TYP     k_step,k_anf,k_start,k_max;
TYP	maximum;
int	nullen;
TYP	energieend1,energieend2;

char dat0[10]="0-had.dat";
char dat1[10]="1-pha.dat";
char dat2[10]="2-pha.dat";
char dat3[10]="3-pha.dat";
char dat4[10]="4-pha.dat";
char dat5[10]="5-pha.dat";
char dat6[10]="6-pha.dat";
char dat7[10]="7-pha.dat";
char dat8[10]="8-pha.dat";
char datl[8]="k-l.dat";

dat=fopen("in.dat","r");
fscanf(dat,"%s\n",&streuung);
fscanf(dat,"%d\n",&drehimpend);
/* fscanf(dat,"%le\n",&k_start); */
k_start=0.0;
fscanf(dat,"%le\n",&k_max);
fscanf(dat,"%le\n",&kappa);
fscanf(dat,"%le\n",&ladung);
fscanf(dat,"%le\n",&dipol);
fscanf(dat,"%le\n",&r0pol);
fscanf(dat,"%le\n",&step);
fscanf(dat,"%le\n",&rela_born1);
fscanf(dat,"%le\n",&rela_born2);
fclose(dat);

/* vorhandene Dateien mit gleichem Namen loeschen */
dat=fopen("k-grenze.dat","w");fclose(dat);
dat=fopen(dat1,"w");fclose(dat);
if( 50<drehimpend )
  {dat=fopen(dat2,"w");fclose(dat);}
if( 100<drehimpend )
  {dat=fopen(dat3,"w");fclose(dat);} 
if( 150<drehimpend )
  {dat=fopen(dat4,"w");fclose(dat);} 
if( 200<drehimpend )
  {dat=fopen(dat5,"w");fclose(dat);} 
if( 500<drehimpend )
  {dat=fopen(dat6,"w");fclose(dat);}
if( 1000<drehimpend	)
  {dat=fopen(dat7,"w");fclose(dat);} 
if( 5000<drehimpend)
  {dat=fopen(dat8,"w");fclose(dat);} 
datl1=fopen(datl,"w");fclose(datl1);


Z=ladung;
setzen();                          /* a_0 und Potential setzen */
zwi=kappa*a_0/A_B;
 pol=dipol;
 r_0=r0pol;


if( k_start<0.1 ) k_anf=0.1;
else k_anf=k_start;
k_step=0.1;
energieend1=k_ende(kappa,rela_born1,k_max,k_anf,k_step);
if( k_start<energieend1 ) k_anf=energieend1;
else k_anf=k_start;
k_step=1.0;
 energieend2=k_ende(kappa,rela_born2,k_max,k_anf,k_step);


dat=fopen(dat0,"w");
fprintf(dat,"%d	\n",drehimpend);
fprintf(dat,"%le \n",energieend1);
fprintf(dat,"%le \n",energieend2);
fprintf(dat,"%le \n",kappa);
fprintf(dat,"%le \n\n",zwi);
fprintf(dat,"%le \n",Z);
fprintf(dat,"%le \n",pol);
fprintf(dat,"%le \n\n",r_0);
fprintf(dat,"%le \n",rela_born1);
fprintf(dat,"%le \n\n",rela_born2);

fprintf(dat,"\n\na: maximale Drehimpulsquantenzahl l\n");
fprintf(dat,"b: maximale Wellenzahl k schritt=0.001\n");
fprintf(dat,"b: maximale Wellenzahl k \n");
fprintf(dat,"c: reziproker Debyeradius kappa [a_0]\n");
fprintf(dat,"d: reziproker Debyeradius kappa [a_B]\n\n");
fprintf(dat,"e: Ladungszahl	Z des Streuers\n");
fprintf(dat,"f: Dipolpolarisierbarkeit des Streuers [a_0^3]\n");
fprintf(dat,"g: r_0 [a_0]\n\n");
fprintf(dat,"h: maximaler, relativer Fehler1 T-matrix <--> Born\n");
fprintf(dat,"   Umschaltung schritt=0.001 --> schritt=0.1\n");
fprintf(dat,"i: maximaler, relativer Fehler2 T-matrix <--> Born\n");
fclose(dat);


a=k_start;
nullen=1;
l_max=0;
schritt=0.001;
next=0;

grenze=cutoff(pot,schritt,kappa,POTTEIL);
maximum=GRENZMAX;
if(fabs(grenze-maximum)	< 0.1)
  {	printf("grenze=%d\n",grenze);
	printf("grenzmax=%le\n",maximum);
	nrerror(" zu weite Integration in phaseexe.c !!!"); }

do{	dat=fopen(dat1,"a");
	fprintf(dat,"%le ",a); 
	for(l=0;l<=50;l++)
	  { if( a < (schritt/2.0) ) ergebnis=l;
	    else ergebnis=phas(a,l,kappa,nullen);
	    if( l>l_max && fabs(ergebnis)<KLEIN ) nullen=-1;
	    if( fabs(ergebnis)>=1.0e-5 || l==0) 
	      { fprintf(dat,"%13.5le ",ergebnis);
	        max_l=l;}
	    if( nullen>0 ) l_max=l; }
	if ( fabs(ergebnis)>=1.0e-5 && a >= (schritt/2.0)) next=1;
	else next=0;
	fprintf(dat,"\n");
	fclose(dat);

	if( next==1)
	  {dat=fopen(dat2,"a");
	   fprintf(dat,"%le ",a); 
	   for(l=51;l<=100;l++)
	     { if( a < (schritt/2.0) ) ergebnis=l;
	       else ergebnis=phas(a,l,kappa,nullen);
	       if( l>l_max && fabs(ergebnis)<KLEIN ) nullen=-1;
	       if( fabs(ergebnis)>=1.0e-5 )
		 { fprintf(dat,"%13.5le ",ergebnis);
	           max_l=l;}
	       if( nullen>0 ) l_max=l; }
	   if ( fabs(ergebnis)>=1.0e-5 && a >= (schritt/2.0)) next=1;
	   else next=0;
	   fprintf(dat,"\n");
	   fclose(dat); }

	if( next==1)
	 { dat=fopen(dat3,"a");
	   fprintf(dat,"%le ",a);
	   for(l=101;l<=150;l++)
	     { if( a < (schritt/2.0) ) ergebnis=l;
	       else ergebnis=phas(a,l,kappa,nullen);
	       if( l>l_max && fabs(ergebnis)<KLEIN ) nullen=-1;
	       if( fabs(ergebnis)>=1.0e-5 ) 
		 { fprintf(dat,"%13.5le ",ergebnis);
	           max_l=l;}
	       if( nullen>0 ) l_max=l; }
	   if ( fabs(ergebnis)>=1.0e-5 && a >= (schritt/2.0)) next=1;
	   else next=0;
	   fprintf(dat,"\n");
	   fclose(dat); }

	if( next==1 )
	 { dat=fopen(dat4,"a");
	   fprintf(dat,"%le ",a);
	   for(l=151;l<=200;l++)
	     { if( a < (schritt/2.0) ) ergebnis=l;
	       else ergebnis=phas(a,l,kappa,nullen);
	       if( l>l_max && fabs(ergebnis)<KLEIN ) nullen=-1;
	       if( fabs(ergebnis)>=1.0e-5 ) 
		 { fprintf(dat,"%13.5le ",ergebnis);
	           max_l=l;}
	       if( nullen>0 ) l_max=l; }
	   if ( fabs(ergebnis)>=1.0e-5 && a >= (schritt/2.0)) next=1;
	   else next=0;
	   fprintf(dat,"\n");
	   fclose(dat); }

	if( next==1)
	 { dat=fopen(dat5,"a");
	   fprintf(dat,"%le ",a);
	   for(l=210;l<501;)
	     { if( a < (schritt/2.0) ) ergebnis=l;
	       else ergebnis=phas(a,l,kappa,nullen);
	       if( l>l_max && fabs(ergebnis)<KLEIN ) nullen=-1;
	       if( fabs(ergebnis)>=1.0e-5 ) 
		 { fprintf(dat,"%13.5le ",ergebnis);
	           max_l=l;}
	       if( nullen>0 ) l_max=l;
	       l=l+10; }
	   if ( fabs(ergebnis)>=1.0e-5 && a >= (schritt/2.0)) next=1;
	   else next=0;
	   fprintf(dat,"\n");
	   fclose(dat); }

	if( next==1 )
	 { dat=fopen(dat6,"a");
	   fprintf(dat,"%le ",a);
	   for(l=510;l<1001;)
	     { if( a < (schritt/2.0) ) ergebnis=l;
	       else ergebnis=phas(a,l,kappa,nullen);
	       if( l>l_max && fabs(ergebnis)<KLEIN ) nullen=-1;
	       if( fabs(ergebnis)>=1.0e-5 ) 
		 { fprintf(dat,"%13.5le ",ergebnis);
	           max_l=l;}
	       if( nullen>0 ) l_max=l;
	       l=l+10; }
	   if ( fabs(ergebnis)>=1.0e-5 && a >= (schritt/2.0)) next=1;
	   else next=0;
           fprintf(dat,"\n");
           fclose(dat); }

	if( next==1 )
	 { dat=fopen(dat7,"a");
	   fprintf(dat,"%le ",a);
	   for(l=1100;l<5001;)
	     { if( a < (schritt/2.0) ) ergebnis=l;
	       else ergebnis=phas(a,l,kappa,nullen);
	       if( l>l_max && fabs(ergebnis)<KLEIN ) nullen=-1;
	       if( fabs(ergebnis)>=1.0e-5 ) 
		 { fprintf(dat,"%13.5le ",ergebnis);
	           max_l=l;}
	       if( nullen>0 ) l_max=l;
	       l=l+100; }
	   if ( fabs(ergebnis)>=1.0e-5 && a >= (schritt/2.0)) next=1;
	   else next=0;
	   fprintf(dat,"\n");
	   fclose(dat); }

	if( next==1)
	 { dat=fopen(dat8,"a");
	   fprintf(dat,"%le ",a);
	   for(l=5100;l<10001;)
	     { if( a < (schritt/2.0) ) ergebnis=l;
	       else ergebnis=phas(a,l,kappa,nullen);
	       if( l>l_max && fabs(ergebnis)<KLEIN ) nullen=-1;
	       if( fabs(ergebnis)>=1.0e-5 ) 
		 { fprintf(dat,"%13.5le ",ergebnis);
	           max_l=l;}
	       if( nullen>0 ) l_max=l;
	       l=l+100; }
	   if ( fabs(ergebnis)>=1.0e-5 && a >= (schritt/2.0)) next=1;
	   else next=0;
	   fprintf(dat,"\n");
	   fclose(dat); }


	datl1=fopen(datl,"a");
	fprintf(datl1,"%le   %d",a,max_l);
	  fprintf(datl1,"\n");
	fclose(datl1); 
	  
        if( a>=0.01 ) schritt=0.01;
        if( a>=1.0 ) schritt=0.1;
        if( (energieend1-a)<schritt/2.0 ) schritt=0.1;
        if( a>=10.0 ) schritt=1.0;
	a+=schritt;
	nullen=1;
  }	while(a<energieend2+schritt+(schritt/2.0));


	datl1=fopen(datl,"a");
	fprintf(datl1,"%d %d",-1,-1);
	  fprintf(datl1,"\n");
	fclose(datl1); 

	/*	printf("fertig mit test");*/

return 0;
}
